###################################################
### chunk number 1: 
###################################################
library(prob)


###################################################
### chunk number 2: 
###################################################
tosscoin(1)


###################################################
### chunk number 3: 
###################################################
tosscoin(3)


###################################################
### chunk number 4: 
###################################################
rolldie(1)


###################################################
### chunk number 5: 
###################################################
cards()


###################################################
### chunk number 6: 
###################################################
urnsamples(1:3, size = 2, replace = TRUE, ordered = TRUE)


###################################################
### chunk number 7: 
###################################################
urnsamples(1:3, size = 2, replace = FALSE, ordered = TRUE)


###################################################
### chunk number 8: 
###################################################
urnsamples(1:3, size = 2, replace = FALSE, ordered = FALSE)


###################################################
### chunk number 9: 
###################################################
urnsamples(1:3, size = 2, replace = TRUE, ordered = FALSE)


###################################################
### chunk number 10: 
###################################################
nsamp(n=3, k=2, replace = TRUE, ordered = TRUE)
nsamp(n=3, k=2, replace = FALSE, ordered = TRUE)
nsamp(n=3, k=2, replace = FALSE, ordered = FALSE)
nsamp(n=3, k=2, replace = TRUE, ordered = FALSE)


###################################################
### chunk number 11: 
###################################################
n = c(11,7,31)
k = c(3,4,3)
r = c(FALSE,FALSE,TRUE)


###################################################
### chunk number 12: 
###################################################
x = nsamp(n, k, rep = r, ord = TRUE)


###################################################
### chunk number 13: 
###################################################
prod(x)


###################################################
### chunk number 14: 
###################################################
(11*10*9)*(7*6*5*4)*31^3


###################################################
### chunk number 15: 
###################################################
prod(9:11)*prod(4:7)*31^3


###################################################
### chunk number 16: 
###################################################
prod(factorial(c(11,7))/factorial(c(8,3)))*31^3


###################################################
### chunk number 17: 
###################################################
outcomes = rolldie(1)
p = rep(1/6, times = 6)
probspace(outcomes, probs = p)


###################################################
### chunk number 18: 
###################################################
probspace(1:6, probs = p)


###################################################
### chunk number 19: 
###################################################
probspace(1:6)


###################################################
### chunk number 20: 
###################################################
rolldie(1, makespace = TRUE)


###################################################
### chunk number 21: 
###################################################
probspace(tosscoin(1), probs = c(0.70, 0.30))


###################################################
### chunk number 22: 
###################################################
iidspace(c("H","T"), ntrials = 3, probs = c(0.7, 0.3))


###################################################
### chunk number 23: 
###################################################
S = tosscoin(2, makespace = TRUE)
S[1:3, ]
S[c(2,4), ]


###################################################
### chunk number 24: 
###################################################
S = cards()


###################################################
### chunk number 25: 
###################################################
subset(S, suit == "Heart")
subset(S, rank %in% 7:9)


###################################################
### chunk number 26: 
###################################################
subset(rolldie(3), X1+X2+X3 > 16)


###################################################
### chunk number 27: 
###################################################
x = 1:10
y = 3:7
y %in% x


###################################################
### chunk number 28: 
###################################################
isin(x,y)


###################################################
### chunk number 29: 
###################################################
x = 1:10
y = c(3,3,7)


###################################################
### chunk number 30: 
###################################################
all(y %in% x)
isin(x,y)


###################################################
### chunk number 31: 
###################################################
isin(x, c(3,4,5), ordered = TRUE)
isin(x, c(3,5,4), ordered = TRUE)


###################################################
### chunk number 32: 
###################################################
S = rolldie(4)
subset(S, isin(S, c(2,2,6), ordered = TRUE))


###################################################
### chunk number 33: 
###################################################
S = cards()
A = subset(S, suit == "Heart")
B = subset(S, rank %in% 7:9)


###################################################
### chunk number 34: 
###################################################
union(A,B)
intersect(A,B)
setdiff(A,B)
setdiff(B,A)


###################################################
### chunk number 35: 
###################################################
S = cards(makespace = TRUE)
A = subset(S, suit == "Heart")
B = subset(S, rank %in% 7:9)


###################################################
### chunk number 36: 
###################################################
prob(A)


###################################################
### chunk number 37: 
###################################################
prob(S, suit == "Heart")


###################################################
### chunk number 38: 
###################################################
prob(A, given = B)
prob(S, suit=="Heart", given = rank %in% 7:9)
prob(B, given = A)


###################################################
### chunk number 39: 
###################################################
prob( intersect(A,B) ) / prob(B)


###################################################
### chunk number 40: 
###################################################
prob( union(A,B) )
prob(A) + prob(B) - prob(intersect(A,B))


###################################################
### chunk number 41: 
###################################################
prob( intersect(A,B) )
prob(A) * prob(B, given = A)


###################################################
### chunk number 42: 
###################################################
S = tosscoin(2, makespace = TRUE)


###################################################
### chunk number 43: 
###################################################
prob(S, toss2 == "H")
prob(S, toss2 == "H", given = toss1=="H")


###################################################
### chunk number 44: 
###################################################
S = cards(makespace=TRUE)
sim(S, ntrials = 5)


###################################################
### chunk number 45: 
###################################################
S = tosscoin(2, makespace = TRUE)
sims = sim(S, ntrials = 50000)
empirical(sims)


###################################################
### chunk number 46: 
###################################################
S = rolldie(3, nsides = 4, makespace = TRUE)
S = addrv(S, U = X1-X2+X3)


###################################################
### chunk number 47: 
###################################################
S[1:9,]


###################################################
### chunk number 48: 
###################################################
prob(S, U > 6)


###################################################
### chunk number 49: 
###################################################
S = addrv(S, FUN = max, invars = c("X1","X2","X3"), name = "V")
S = addrv(S, FUN = sum, invars = c("X1","X2","X3"), name = "W")
S[1:9,]


###################################################
### chunk number 50: 
###################################################
marginal(S, vars = "V")


###################################################
### chunk number 51: 
###################################################
marginal(S, vars = c("V", "W"))


###################################################
### chunk number 52: 
###################################################
L = cards()
M = urnsamples(L, 2)
N = probspace(M)


###################################################
### chunk number 53: 
###################################################
A = subset(N, all(suit=="Heart"))
B = subset(N, any(suit=="Heart"))
C = subset(N, any(suit=="Heart") & all(rank=="A"))
D = subset(N, any(suit=="Spade") & any(rank=="A"))


###################################################
### chunk number 54: 
###################################################
prob(A)
prob(B)
prob(C, given = D)
prob(D, given = C)


###################################################
### chunk number 55: 
###################################################
library(combinat)
out = data.frame(t(xsimplex(3,2)))
p = apply(out, MARGIN = 1, FUN = dmultinom, prob = c(1,1,1))


###################################################
### chunk number 56: 
###################################################
S = probspace(out, p)


###################################################
### chunk number 57: 
###################################################
x = rep(c("Red", "Blue"), times = c(4,10))
P = urnsamples(x, size = 3, replace = FALSE, ordered = FALSE)
Q = probspace(P)


###################################################
### chunk number 58: 
###################################################
noorder(Q)


###################################################
### chunk number 59: 
###################################################
dhyper(0:3, 4, 10, 3)


